import { Component, Injector, ViewEncapsulation, ViewChild } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { ClinicsServiceProxy, ClinicDto  } from '@shared/service-proxies/service-proxies';
import { NotifyService } from '@abp/notify/notify.service';
import { AppComponentBase } from '@shared/common/app-component-base';
import { TokenAuthServiceProxy } from '@shared/service-proxies/service-proxies';
import { CreateOrEditClinicModalComponent } from './create-or-edit-clinic-modal.component';
import { ViewClinicModalComponent } from './view-clinic-modal.component';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { Table } from 'primeng/components/table/table';
import { Paginator } from 'primeng/components/paginator/paginator';
import { LazyLoadEvent } from 'primeng/components/common/lazyloadevent';
import { FileDownloadService } from '@shared/utils/file-download.service';
import { EntityTypeHistoryModalComponent } from '@app/shared/common/entityHistory/entity-type-history-modal.component';
import * as _ from 'lodash';
import * as moment from 'moment';
import { Router } from '@angular/router';
import { HttpClient } from '@angular/common/http';

@Component({
    templateUrl: './clinics.component.html',
    encapsulation: ViewEncapsulation.None,
    animations: [appModuleAnimation()]
})
export class ClinicsComponent extends AppComponentBase {

    @ViewChild('createOrEditClinicModal', { static: true }) createOrEditClinicModal: CreateOrEditClinicModalComponent;
    @ViewChild('viewClinicModalComponent', { static: true }) viewClinicModal: ViewClinicModalComponent;
    @ViewChild('entityTypeHistoryModal', { static: true }) entityTypeHistoryModal: EntityTypeHistoryModalComponent;
    @ViewChild('dataTable', { static: true }) dataTable: Table;
    @ViewChild('paginator', { static: true }) paginator: Paginator;

    advancedFiltersAreShown = false;
    filterText = '';
    clinicNotesFilter = '';
    billingNotesFilter = '';
    clinicNameFilter = '';
    clinicAccountFilter = '';
    clinicAddressFilter = '';
    maxContactIdFilter : number;
		maxContactIdFilterEmpty : number;
		minContactIdFilter : number;
		minContactIdFilterEmpty : number;


    _entityTypeFullName = 'SprintTek.Laboratory.Clinic';
    entityHistoryEnabled = false;

    constructor(
        injector: Injector,
        private _clinicsServiceProxy: ClinicsServiceProxy,
        private _notifyService: NotifyService,
        private _tokenAuth: TokenAuthServiceProxy,
        private _activatedRoute: ActivatedRoute,
        private _fileDownloadService: FileDownloadService,
        private _httpClient: HttpClient,
        private _router: Router,
    ) {
        super(injector);
    }

    ngOnInit(): void {
        this.entityHistoryEnabled = this.setIsEntityHistoryEnabled();
    }

    private setIsEntityHistoryEnabled(): boolean {
        let customSettings = (abp as any).custom;
        return customSettings.EntityHistory && customSettings.EntityHistory.isEnabled && _.filter(customSettings.EntityHistory.enabledEntities, entityType => entityType === this._entityTypeFullName).length === 1;
    }

    getClinics(event?: LazyLoadEvent) {
        if (this.primengTableHelper.shouldResetPaging(event)) {
            this.paginator.changePage(0);
            return;
        }

        this.spinnerService.show();

        this._clinicsServiceProxy.getAll(
            this.filterText,
            this.clinicNotesFilter,
            this.billingNotesFilter,
            this.clinicAccountFilter,
            this.clinicNameFilter,
            this.clinicAddressFilter,
            this.maxContactIdFilter == null ? this.maxContactIdFilterEmpty: this.maxContactIdFilter,
            this.minContactIdFilter == null ? this.minContactIdFilterEmpty: this.minContactIdFilter,
            this.primengTableHelper.getSorting(this.dataTable),
            this.primengTableHelper.getSkipCount(this.paginator, event),
            this.primengTableHelper.getMaxResultCount(this.paginator, event)
        ).subscribe(result => {
            this.primengTableHelper.totalRecordsCount = result.totalCount;
            this.primengTableHelper.records = result.items;
            console.log(result.items);
            this.primengTableHelper.hideLoadingIndicator();
            this.spinnerService.hide();
        });
    }

    reloadPage(): void {
        this.paginator.changePage(this.paginator.getPage());
    }

    createClinic(): void {
        this.createOrEditClinicModal.show();
    }

    showHistory(clinic: ClinicDto): void {
        this.entityTypeHistoryModal.show({
            entityId: clinic.id.toString(),
            entityTypeFullName: this._entityTypeFullName,
            entityTypeDescription: ''
        });
    }

    deleteClinic(clinic: ClinicDto): void {
        this.message.confirm(
            '',
            (isConfirmed) => {
                if (isConfirmed) {
                    this._clinicsServiceProxy.delete(clinic.id)
                        .subscribe(() => {
                            this.reloadPage();
                            this.notify.success(this.l('SuccessfullyDeleted'));
                        });
                }
            }
        );
    }

    exportToExcel(): void {
        this._clinicsServiceProxy.getClinicsToExcel(
        this.filterText,
            this.clinicNotesFilter,
            this.billingNotesFilter,
            this.maxContactIdFilter == null ? this.maxContactIdFilterEmpty: this.maxContactIdFilter,
            this.minContactIdFilter == null ? this.minContactIdFilterEmpty: this.minContactIdFilter,
            this.clinicAccountFilter,
            this.clinicNameFilter,
        )
        .subscribe(result => {
            this._fileDownloadService.downloadTempFile(result);
         });
    }

    createOrEditClinic(url: any, id?: number){
        if(id != null){
            var myurl = `${url}/${id}`;
        }else{
            var myurl = `${url}`;
        }
        console.log(myurl);
        this._router.navigateByUrl(myurl);
    }
}
